Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -5298,23 +5752,31 @@
         ////////////////////
         case ALLOC_DIR_SC:
-        if ( ((r_sc_fsm.read() != SC_DIR_LOCK)       &&
-              (r_sc_fsm.read() != SC_DIR_HIT_READ )  &&
-              (r_sc_fsm.read() != SC_DIR_HIT_WRITE ) &&
-//              (r_sc_fsm.read() != SC_MISS_TRT_LOCK )    &&
-              (r_sc_fsm.read() != SC_BC_TRT_LOCK)       &&
-              (r_sc_fsm.read() != SC_BC_UPT_LOCK)     &&
-              (r_sc_fsm.read() != SC_UPT_LOCK)       &&
-              (r_sc_fsm.read() != SC_UPT_HEAP_LOCK))
+        if ((( r_sc_fsm.read()         != SC_DIR_REQ       )  &&
+             ( r_sc_fsm.read()         != SC_DIR_LOCK      )  &&
+             ( r_sc_fsm.read()         != SC_DIR_HIT_READ  )  &&
+             ( r_sc_fsm.read()         != SC_DIR_HIT_WRITE )  &&
+             ( r_sc_fsm.read()         != SC_BC_TRT_LOCK   )  &&
+             ( r_sc_fsm.read()         != SC_BC_UPT_LOCK   )  &&
+             ( r_sc_fsm.read()         != SC_MISS_TRT_LOCK )  &&
+             ( r_sc_fsm.read()         != SC_UPT_LOCK      )  &&
+             ( r_sc_fsm.read()         != SC_UPT_HEAP_LOCK ))
             ||
-            ( (r_sc_fsm.read()       == SC_UPT_HEAP_LOCK) &&
-              (r_alloc_heap_fsm.read() == ALLOC_HEAP_SC) )
+            (( r_sc_fsm.read()         == SC_UPT_HEAP_LOCK )  &&
+             ( r_alloc_heap_fsm.read() == ALLOC_HEAP_SC    ))
             ||
-            ( (r_sc_fsm.read()      == SC_MISS_TRT_LOCK ) &&
-              (r_alloc_trt_fsm.read() == ALLOC_TRT_SC)    ) )
-        {
-          if      (r_cleanup_fsm.read() == CLEANUP_DIR_LOCK)    r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)  r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
-          else if (r_read_fsm.read() == READ_DIR_LOCK) 	        r_alloc_dir_fsm = ALLOC_DIR_READ;
-          else if (r_write_fsm.read() == WRITE_DIR_LOCK)        r_alloc_dir_fsm = ALLOC_DIR_WRITE;
+            (( r_sc_fsm.read()         == SC_MISS_TRT_LOCK )  &&
+             ( r_alloc_trt_fsm.read()  == ALLOC_TRT_SC     )))
+        {
+          if ( r_cleanup_fsm.read() == CLEANUP_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK )
+            r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_READ;
+
+          else if ( r_write_fsm.read() == WRITE_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_WRITE;
         }
         break;
@@ -5322,23 +5784,40 @@
         ///////////////////////
         case ALLOC_DIR_CLEANUP:
-        if ( (r_cleanup_fsm.read() != CLEANUP_DIR_LOCK) &&
-            (r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK) )
-        {
-          if        (r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)    r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
-          else if   (r_read_fsm.read() == READ_DIR_LOCK)            r_alloc_dir_fsm = ALLOC_DIR_READ;
-          else if   (r_write_fsm.read() == WRITE_DIR_LOCK)          r_alloc_dir_fsm = ALLOC_DIR_WRITE;
-          else if   (r_sc_fsm.read() == SC_DIR_LOCK)              r_alloc_dir_fsm = ALLOC_DIR_SC;
+        if (( r_cleanup_fsm.read() != CLEANUP_DIR_REQ   ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_DIR_LOCK  ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_HEAP_REQ  ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK ))
+        {
+          if ( r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK )
+            r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_READ;
+
+          else if ( r_write_fsm.read() == WRITE_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_WRITE;
+
+          else if ( r_sc_fsm.read() == SC_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_SC;
         }
         break;
+
         ////////////////////////
         case ALLOC_DIR_XRAM_RSP:
-        if ( (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK)  &&
-            (r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY)   && 
-            (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK))
-        {
-          if      (r_read_fsm.read() == READ_DIR_LOCK) 	        r_alloc_dir_fsm = ALLOC_DIR_READ;
-          else if (r_write_fsm.read() == WRITE_DIR_LOCK)        r_alloc_dir_fsm = ALLOC_DIR_WRITE;
-          else if (r_sc_fsm.read() == SC_DIR_LOCK)            r_alloc_dir_fsm = ALLOC_DIR_SC;
-          else if (r_cleanup_fsm.read() == CLEANUP_DIR_LOCK)    r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
+        if (( r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK   ) &&
+            ( r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY   ) &&
+            ( r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK ))
+        {
+          if ( r_read_fsm.read() == READ_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_READ;
+
+          else if ( r_write_fsm.read() == WRITE_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_WRITE;
+
+          else if ( r_sc_fsm.read() == SC_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_SC;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_DIR_REQ )
+            r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
         }
         break;
@@ -5347,5 +5826,5 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		ALLOC_TRT FSM
+    //    ALLOC_TRT FSM
     ////////////////////////////////////////////////////////////////////////////////////
     // The ALLOC_TRT fsm allocates the access to the Transaction Table (write buffer)
@@ -5355,72 +5834,118 @@
     ///////////////////////////////////////////////////////////////////////////////////
 
-    switch (r_alloc_trt_fsm) 
+    switch ( r_alloc_trt_fsm.read() )
     {
-
       ////////////////////
       case ALLOC_TRT_READ:
-        if ( r_read_fsm.read() != READ_TRT_LOCK ) 
-        {
-          if      ((r_write_fsm.read() == WRITE_MISS_TRT_LOCK)   ||
-                   (r_write_fsm.read() == WRITE_BC_TRT_LOCK))    r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-          else if ((r_sc_fsm.read() == SC_MISS_TRT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_TRT_LOCK))              r_alloc_trt_fsm = ALLOC_TRT_SC;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_TRT_COPY)      r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-          else if ( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-                    (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ) )    r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+        if ( r_read_fsm.read() != READ_TRT_LOCK )
+        {
+          if (( r_write_fsm.read() == WRITE_MISS_TRT_LOCK ) ||
+              ( r_write_fsm.read() == WRITE_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+          else if (( r_sc_fsm.read() == SC_MISS_TRT_LOCK ) ||
+                   ( r_sc_fsm.read() == SC_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_SC;
+
+          else if (( r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK  ) &&
+                   ( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ))
+            r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+          else if (( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE ) ||
+                   ( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ  ))
+            r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
         }
         break;
-        /////////////////////
+
+      /////////////////////
       case ALLOC_TRT_WRITE:
-        if ( (r_write_fsm.read() != WRITE_MISS_TRT_LOCK) &&
-             (r_write_fsm.read() != WRITE_BC_TRT_LOCK) &&
-             (r_write_fsm.read() != WRITE_BC_UPT_LOCK)) 
-        {
-          if      ((r_sc_fsm.read() == SC_MISS_TRT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_TRT_LOCK))              r_alloc_trt_fsm = ALLOC_TRT_SC;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_TRT_COPY)      r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-          else if ( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-                    (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))     r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-          else if (r_read_fsm.read() == READ_TRT_LOCK) 	            r_alloc_trt_fsm = ALLOC_TRT_READ;
+        if (( r_write_fsm.read() != WRITE_MISS_TRT_LOCK ) &&
+            ( r_write_fsm.read() != WRITE_BC_TRT_LOCK   ) &&
+            ( r_write_fsm.read() != WRITE_BC_UPT_LOCK   ))
+        {
+          if (( r_sc_fsm.read() == SC_MISS_TRT_LOCK ) ||
+              ( r_sc_fsm.read() == SC_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_SC;
+
+          else if (( r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK  ) &&
+                   ( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ))
+            r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+          else if (( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE ) ||
+                   ( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ  ))
+            r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+          else if ( r_read_fsm.read() == READ_TRT_LOCK )
+            r_alloc_trt_fsm = ALLOC_TRT_READ;
         }
         break;
-        ////////////////////
+
+      ////////////////////
       case ALLOC_TRT_SC:
-        if ( (r_sc_fsm.read() != SC_MISS_TRT_LOCK) &&
-             (r_sc_fsm.read() != SC_BC_TRT_LOCK) &&
-             (r_sc_fsm.read() != SC_BC_UPT_LOCK))
-        { 
-          if      (r_xram_rsp_fsm.read() == XRAM_RSP_TRT_COPY)      r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-          else if ( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-                    (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))     r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-          else if (r_read_fsm.read() == READ_TRT_LOCK) 	            r_alloc_trt_fsm = ALLOC_TRT_READ;
-          else if ((r_write_fsm.read() == WRITE_MISS_TRT_LOCK)     ||
-                   (r_write_fsm.read() == WRITE_BC_TRT_LOCK))    r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+        if (( r_sc_fsm.read() != SC_MISS_TRT_LOCK ) &&
+            ( r_sc_fsm.read() != SC_BC_TRT_LOCK   ) &&
+            ( r_sc_fsm.read() != SC_BC_UPT_LOCK   ))
+        {
+          if (( r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK  ) &&
+              ( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ))
+            r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+          else if (( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE ) ||
+                   ( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ  ))
+            r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+          else if ( r_read_fsm.read() == READ_TRT_LOCK )
+            r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+          else if (( r_write_fsm.read() == WRITE_MISS_TRT_LOCK ) ||
+                   ( r_write_fsm.read() == WRITE_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_WRITE;
         }
         break;
-        ////////////////////////
+
+      ////////////////////////
       case ALLOC_TRT_XRAM_RSP:
-        if ( (r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY)  &&
-            (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_UPDT)   &&
-            (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK)) {
-          if      ( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-                    (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))     r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-          else if (r_read_fsm.read() == READ_TRT_LOCK) 	            r_alloc_trt_fsm = ALLOC_TRT_READ;
-          else if ((r_write_fsm.read() == WRITE_MISS_TRT_LOCK)    ||
-                   (r_write_fsm.read() == WRITE_BC_TRT_LOCK))    r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-          else if ((r_sc_fsm.read() == SC_MISS_TRT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_TRT_LOCK))              r_alloc_trt_fsm = ALLOC_TRT_SC;
+        if ((( r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_LOCK   )  ||
+             ( r_alloc_dir_fsm.read() != ALLOC_DIR_XRAM_RSP  )) &&
+             ( r_xram_rsp_fsm.read()  != XRAM_RSP_TRT_COPY   )  &&
+             ( r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_UPDT   )  &&
+             ( r_xram_rsp_fsm.read()  != XRAM_RSP_INVAL_LOCK ))
+        {
+          if (( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE ) ||
+              ( r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ  ))
+            r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+          else if ( r_read_fsm.read() == READ_TRT_LOCK )
+            r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+          else if (( r_write_fsm.read() == WRITE_MISS_TRT_LOCK ) ||
+                   ( r_write_fsm.read() == WRITE_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+          else if (( r_sc_fsm.read() == SC_MISS_TRT_LOCK ) ||
+                   ( r_sc_fsm.read() == SC_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_SC;
         }
         break;
-        ////////////////////////
+
+      ////////////////////////
       case ALLOC_TRT_IXR_RSP:
-        if ( (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_ERASE) &&
-            (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ) ) {
-          if      (r_read_fsm.read() == READ_TRT_LOCK) 	            r_alloc_trt_fsm = ALLOC_TRT_READ;
-          else if ((r_write_fsm.read() == WRITE_MISS_TRT_LOCK)   ||
-                   (r_write_fsm.read() == WRITE_BC_TRT_LOCK))    r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-          else if ((r_sc_fsm.read() == SC_MISS_TRT_LOCK) ||
-                   (r_sc_fsm.read() == SC_BC_TRT_LOCK))              r_alloc_trt_fsm = ALLOC_TRT_SC;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_TRT_COPY)      r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+        if (( r_ixr_rsp_fsm.read() != IXR_RSP_TRT_ERASE ) &&
+            ( r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ  ))
+        {
+          if ( r_read_fsm.read() == READ_TRT_LOCK )
+            r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+          else if (( r_write_fsm.read() == WRITE_MISS_TRT_LOCK ) ||
+                   ( r_write_fsm.read() == WRITE_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+          else if (( r_sc_fsm.read() == SC_MISS_TRT_LOCK ) ||
+                   ( r_sc_fsm.read() == SC_BC_TRT_LOCK   ))
+            r_alloc_trt_fsm = ALLOC_TRT_SC;
+
+          else if (( r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK  ) &&
+                   ( r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP ))
+            r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
         }
         break;
@@ -5429,5 +5954,5 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		ALLOC_HEAP FSM
+    //    ALLOC_HEAP FSM
     ////////////////////////////////////////////////////////////////////////////////////
     // The ALLOC_HEAP FSM allocates the access to the heap
@@ -5437,15 +5962,36 @@
     /////////////////////////////////////////////////////////////////////////////////////
 
-    switch ( r_alloc_heap_fsm.read() ) 
+    switch ( r_alloc_heap_fsm.read() )
     {
         ////////////////////
+        case ALLOC_HEAP_RESET:
+          // Initializes the heap one ENTRY each cycle.
+
+          r_alloc_heap_reset_cpt.write(r_alloc_heap_reset_cpt.read() + 1);
+
+          if(r_alloc_heap_reset_cpt.read() == (m_heap_size-1)) {
+            m_heap.init();
+
+            r_alloc_heap_fsm = ALLOC_HEAP_READ;
+          }
+          break;
+
+        ////////////////////
         case ALLOC_HEAP_READ:
-        if (  (r_read_fsm.read() != READ_HEAP_LOCK) &&
-              (r_read_fsm.read() != READ_HEAP_ERASE)     ) 
-        {
-          if      (r_write_fsm.read() == WRITE_UPT_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
-          else if (r_sc_fsm.read() == SC_UPT_HEAP_LOCK)              r_alloc_heap_fsm = ALLOC_HEAP_SC;
-          else if (r_cleanup_fsm.read() == CLEANUP_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_ERASE) r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
+        if (( r_read_fsm.read() != READ_HEAP_REQ   ) &&
+            ( r_read_fsm.read() != READ_HEAP_LOCK  ) &&
+            ( r_read_fsm.read() != READ_HEAP_ERASE ))
+        {
+          if ( r_write_fsm.read() == WRITE_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
+
+          else if ( r_sc_fsm.read() == SC_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_SC;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
         }
         break;
@@ -5453,12 +5999,19 @@
         /////////////////////
         case ALLOC_HEAP_WRITE:
-        if (  (r_write_fsm.read() != WRITE_UPT_HEAP_LOCK)   &&
-              (r_write_fsm.read() != WRITE_UPT_REQ)     &&
-              (r_write_fsm.read() != WRITE_UPT_NEXT)  )
-        {
-          if      (r_sc_fsm.read() == SC_UPT_HEAP_LOCK)          r_alloc_heap_fsm = ALLOC_HEAP_SC;
-          else if (r_cleanup_fsm.read() == CLEANUP_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_ERASE) r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
-          else if (r_read_fsm.read() == READ_HEAP_LOCK) 	     r_alloc_heap_fsm = ALLOC_HEAP_READ;
+        if (( r_write_fsm.read() != WRITE_UPT_HEAP_LOCK ) &&
+            ( r_write_fsm.read() != WRITE_UPT_REQ       ) &&
+            ( r_write_fsm.read() != WRITE_UPT_NEXT      ))
+        {
+          if ( r_sc_fsm.read() == SC_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_SC;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_READ;
         }
         break;
@@ -5466,12 +6019,19 @@
         ////////////////////
         case ALLOC_HEAP_SC:
-        if (  (r_sc_fsm.read() != SC_UPT_HEAP_LOCK)  &&
-              (r_sc_fsm.read() != SC_UPT_REQ )    &&
-              (r_sc_fsm.read() != SC_UPT_NEXT)  )
-        {
-          if      (r_cleanup_fsm.read() == CLEANUP_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
-          else if (r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_ERASE) r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
-          else if (r_read_fsm.read() == READ_HEAP_LOCK)          r_alloc_heap_fsm = ALLOC_HEAP_READ;
-          else if (r_write_fsm.read() == WRITE_UPT_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
+        if (( r_sc_fsm.read() != SC_UPT_HEAP_LOCK ) &&
+            ( r_sc_fsm.read() != SC_UPT_REQ       ) &&
+            ( r_sc_fsm.read() != SC_UPT_NEXT      ))
+        {
+          if ( r_cleanup_fsm.read() == CLEANUP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
+
+          else if ( r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_READ;
+
+          else if ( r_write_fsm.read() == WRITE_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
         }
         break;
@@ -5479,22 +6039,40 @@
         ///////////////////////
         case ALLOC_HEAP_CLEANUP:
-        if ( (r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK) &&
-            (r_cleanup_fsm.read() != CLEANUP_HEAP_SEARCH)&&
-            (r_cleanup_fsm.read() != CLEANUP_HEAP_CLEAN)    )
-        {
-          if      (r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_ERASE) r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
-          else if (r_read_fsm.read() == READ_HEAP_LOCK)          r_alloc_heap_fsm = ALLOC_HEAP_READ;
-          else if (r_write_fsm.read() == WRITE_UPT_HEAP_LOCK)    r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
-          else if (r_sc_fsm.read() == SC_UPT_HEAP_LOCK)          r_alloc_heap_fsm = ALLOC_HEAP_SC;
+        if (( r_cleanup_fsm.read() != CLEANUP_HEAP_REQ    ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK   ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_HEAP_SEARCH ) &&
+            ( r_cleanup_fsm.read() != CLEANUP_HEAP_CLEAN  ))
+        {
+          if ( r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
+
+          else if ( r_read_fsm.read() == READ_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_READ;
+
+          else if ( r_write_fsm.read() == WRITE_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
+
+          else if ( r_sc_fsm.read() == SC_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_SC;
         }
         break;
+
         ////////////////////////
         case ALLOC_HEAP_XRAM_RSP:
-        if ( r_xram_rsp_fsm.read() != XRAM_RSP_HEAP_ERASE )
-        {
-          if        (r_read_fsm.read() == READ_HEAP_LOCK) 	    r_alloc_heap_fsm = ALLOC_HEAP_READ;
-          else if   (r_write_fsm.read() == WRITE_UPT_HEAP_LOCK) r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
-          else if   (r_sc_fsm.read() == SC_UPT_HEAP_LOCK)       r_alloc_heap_fsm = ALLOC_HEAP_SC;
-          else if   (r_cleanup_fsm.read() == CLEANUP_HEAP_LOCK) r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
+        if (( r_xram_rsp_fsm.read() != XRAM_RSP_HEAP_REQ   ) &&
+            ( r_xram_rsp_fsm.read() != XRAM_RSP_HEAP_ERASE ))
+        {
+          if  ( r_read_fsm.read() == READ_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_READ;
+
+          else if ( r_write_fsm.read() == WRITE_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
+
+          else if ( r_sc_fsm.read() == SC_UPT_HEAP_LOCK )
+            r_alloc_heap_fsm = ALLOC_HEAP_SC;
+
+          else if ( r_cleanup_fsm.read() == CLEANUP_HEAP_REQ )
+            r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
+
         }
         break;
@@ -5504,5 +6082,5 @@
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		TGT_CMD to READ FIFO
+    //    TGT_CMD to READ FIFO
     ////////////////////////////////////////////////////////////////////////////////////
 
@@ -5531,5 +6109,5 @@
     }
     /////////////////////////////////////////////////////////////////////
-    //		TGT_CMD to WRITE FIFO
+    //    TGT_CMD to WRITE FIFO
     /////////////////////////////////////////////////////////////////////
 
@@ -5564,5 +6142,5 @@
     }
     ////////////////////////////////////////////////////////////////////////////////////
-    //		TGT_CMD to SC FIFO
+    //    TGT_CMD to SC FIFO
     ////////////////////////////////////////////////////////////////////////////////////
 
@@ -5570,5 +6148,5 @@
       if ( cmd_sc_fifo_get ) {
         m_cmd_sc_addr_fifo.put_and_get((addr_t)(p_vci_tgt.address.read()));
-        m_cmd_sc_eop_fifo.put_and_get(p_vci_tgt.eop.read()); 
+        m_cmd_sc_eop_fifo.put_and_get(p_vci_tgt.eop.read());
         m_cmd_sc_srcid_fifo.put_and_get(p_vci_tgt.srcid.read());
         m_cmd_sc_trdid_fifo.put_and_get(p_vci_tgt.trdid.read());
@@ -5577,5 +6155,5 @@
       } else {
         m_cmd_sc_addr_fifo.simple_put((addr_t)(p_vci_tgt.address.read()));
-        m_cmd_sc_eop_fifo.simple_put(p_vci_tgt.eop.read()); 
+        m_cmd_sc_eop_fifo.simple_put(p_vci_tgt.eop.read());
         m_cmd_sc_srcid_fifo.simple_put(p_vci_tgt.srcid.read());
         m_cmd_sc_trdid_fifo.simple_put(p_vci_tgt.trdid.read());
@@ -5594,5 +6172,5 @@
     }
     ////////////////////////////////////////////////////////////////////////////////////
-    //		WRITE to INIT_CMD FIFO
+    //    WRITE to INIT_CMD FIFO
     ////////////////////////////////////////////////////////////////////////////////////
 
@@ -5621,5 +6199,5 @@
     }
     ////////////////////////////////////////////////////////////////////////////////////
-    //		XRAM_RSP to INIT_CMD FIFO
+    //    XRAM_RSP to INIT_CMD FIFO
     ////////////////////////////////////////////////////////////////////////////////////
 
@@ -5648,5 +6226,5 @@
     }
     ////////////////////////////////////////////////////////////////////////////////////
-    //		SC to INIT_CMD FIFO
+    //    SC to INIT_CMD FIFO
     ////////////////////////////////////////////////////////////////////////////////////
 
@@ -5704,5 +6282,5 @@
       p_vci_ixr.trdid   = r_read_to_ixr_cmd_trdid.read();
       p_vci_ixr.eop     = true;
-    } 
+    }
     else if ( r_ixr_cmd_fsm.read() == IXR_CMD_SC_NLINE ) {
       if(r_sc_to_ixr_cmd_write.read()){
@@ -5723,5 +6301,5 @@
         p_vci_ixr.eop     = true;
       }
-    } 
+    }
     else if ( r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_NLINE ) {
       if(r_write_to_ixr_cmd_write.read()){
@@ -5742,5 +6320,5 @@
         p_vci_ixr.eop     = true;
       }
-    } 
+    }
     else if ( r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_DATA ) {
       p_vci_ixr.cmd     = vci_param::CMD_WRITE;
@@ -5757,5 +6335,5 @@
       p_vci_ixr.wdata   = 0;
       p_vci_ixr.trdid   = 0;
-      p_vci_ixr.eop	= false;
+      p_vci_ixr.eop = false;
     }
 
@@ -5765,5 +6343,5 @@
 
     if ( ((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) &&
-          (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ)) || 
+          (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ)) ||
         (r_ixr_rsp_fsm.read() == IXR_RSP_ACK) ) p_vci_ixr.rspack = true;
     else                                        p_vci_ixr.rspack = false;
@@ -5808,5 +6386,5 @@
         p_vci_tgt.rtrdid  = 0;
         p_vci_tgt.rerror  = 0;
-        p_vci_tgt.reop    = false;	
+        p_vci_tgt.reop    = false;
         break;
       case TGT_RSP_READ:
@@ -5825,5 +6403,5 @@
         p_vci_tgt.rtrdid   = r_write_to_tgt_rsp_trdid.read();
         p_vci_tgt.rpktid   = r_write_to_tgt_rsp_pktid.read();
-        p_vci_tgt.rerror   = 0x2 & ( (1 << vci_param::E) - 1); 
+        p_vci_tgt.rerror   = 0x2 & ( (1 << vci_param::E) - 1);
         p_vci_tgt.reop     = true;
         break;
@@ -5853,7 +6431,7 @@
         p_vci_tgt.rpktid   = r_xram_rsp_to_tgt_rsp_pktid.read();
         p_vci_tgt.rerror   = r_xram_rsp_to_tgt_rsp_rerror.read();
-        p_vci_tgt.reop     = (( r_tgt_rsp_cpt.read() 
-                                == (r_xram_rsp_to_tgt_rsp_word.read()+r_xram_rsp_to_tgt_rsp_length.read()-1))
-                              || r_xram_rsp_to_tgt_rsp_rerror.read());
+        p_vci_tgt.reop     = (( r_tgt_rsp_cpt.read()
+              == (r_xram_rsp_to_tgt_rsp_word.read()+r_xram_rsp_to_tgt_rsp_length.read()-1))
+            || r_xram_rsp_to_tgt_rsp_rerror.read());
         break;
       case TGT_RSP_INIT:
@@ -5864,5 +6442,5 @@
         p_vci_tgt.rpktid   = r_init_rsp_to_tgt_rsp_pktid.read();
         p_vci_tgt.rerror   = 0; // Can be a SC rsp
-        p_vci_tgt.reop     = true;	
+        p_vci_tgt.reop     = true;
         break;
     } // end switch r_tgt_rsp_fsm
@@ -6143,4 +6721,3 @@
 // End:
 
-// vim: filetype=cpp:expandtab:shiftwidth=4:tabstop=4:softtabstop=4
-
+// vim: filetype=cpp:expandtab:shiftwidth=2:tabstop=2:softtabstop=2
